// DisplayAspectDlg.cpp : t@C
//

#include "stdafx.h"
#include "PCRPlayer.h"
#include "DisplayAspectDlg.h"
//#include "afxdialogex.h"

#define TOTAL_COUNT (30) // 

// CDisplayAspectDlg _CAO

IMPLEMENT_DYNAMIC(CDisplayAspectDlg, CDialog)

CDisplayAspectDlg::CDisplayAspectDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDisplayAspectDlg::IDD, pParent)
	, orderAspect_(false)
{

}

CDisplayAspectDlg::~CDisplayAspectDlg()
{
}

void CDisplayAspectDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST_ASPECT, m_xcListAspect);
	DDX_Control(pDX, IDC_BTN_ASPECT_UP, m_xcBtnAspectUp);
	DDX_Control(pDX, IDC_BTN_ASPECT_DOWN, m_xcBtnAspectDown);
	DDX_Control(pDX, IDC_EDIT_ASPECT1, m_xcEditAspect1);
	DDX_Control(pDX, IDC_SPIN_ASPECT1, m_xcSpinAspect1);
	DDX_Control(pDX, IDC_EDIT_ASPECT2, m_xcEditAspect2);
	DDX_Control(pDX, IDC_SPIN_ASPECT2, m_xcSpinAspect2);
}


BEGIN_MESSAGE_MAP(CDisplayAspectDlg, CDialog)
	ON_NOTIFY(LVN_GETDISPINFO, IDC_LIST_ASPECT, &CDisplayAspectDlg::OnLvnGetdispinfoListAspect)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LIST_ASPECT, &CDisplayAspectDlg::OnLvnItemchangedListAspect)
	ON_NOTIFY(LVN_COLUMNCLICK, IDC_LIST_ASPECT, &CDisplayAspectDlg::OnLvnColumnclickListAspect)
	ON_EN_CHANGE(IDC_EDIT_ASPECT1, &CDisplayAspectDlg::OnEnChangeEditAspect1)
	ON_EN_CHANGE(IDC_EDIT_ASPECT2, &CDisplayAspectDlg::OnEnChangeEditAspect2)
	ON_BN_CLICKED(IDC_BTN_ASPECT_UP, &CDisplayAspectDlg::OnBnClickedBtnAspectUp)
	ON_BN_CLICKED(IDC_BTN_ASPECT_DOWN, &CDisplayAspectDlg::OnBnClickedBtnAspectDown)
	ON_BN_CLICKED(IDC_BTN_ASPECT_ALL_DEFAULT, &CDisplayAspectDlg::OnBnClickedBtnAspectAllDefault)
END_MESSAGE_MAP()


// CDisplayAspectDlg bZ[W nh[
BOOL CDisplayAspectDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_xcListAspect.SetExtendedStyle(m_xcListAspect.GetExtendedStyle()|
		LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES|LVS_EX_INFOTIP|LVS_EX_DOUBLEBUFFER);

	m_xcListAspect.InsertColumn(0, L"AXyNg", LVCFMT_LEFT, 120);

	m_xcListAspect.SetItemCountEx(static_cast<int>(aspect_.size()), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

	m_xcSpinAspect1.SetRange32(1, INT_MAX);
	m_xcSpinAspect1.SetPos32(4);
	m_xcSpinAspect2.SetRange32(1, INT_MAX);
	m_xcSpinAspect2.SetPos32(3);

	if (aspect_.size() > 0)
	{
		m_xcListAspect.SetItemState(0, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcListAspect.EnsureVisible(0, FALSE);
	}
	else
	{
		m_xcEditAspect1.EnableWindow(FALSE);
		m_xcSpinAspect1.EnableWindow(FALSE);
		m_xcEditAspect2.EnableWindow(FALSE);
		m_xcSpinAspect2.EnableWindow(FALSE);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}


BOOL CDisplayAspectDlg::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_KEYDOWN)
	{
		if (pMsg->wParam == VK_RETURN || pMsg->wParam == VK_ESCAPE)
		{
			return FALSE;
		}
	}
	return CDialog::PreTranslateMessage(pMsg);
}


void CDisplayAspectDlg::OnLvnGetdispinfoListAspect(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLVDISPINFO *pDispInfo = reinterpret_cast<NMLVDISPINFO*>(pNMHDR);
	if (!pDispInfo) { return; }
	int i = pDispInfo->item.iItem;

	if (pDispInfo->item.mask & LVIF_TEXT)
	{ 
		CString csLine;
		switch (pDispInfo->item.iSubItem)
		{
		case 0:
			{
				try {
					sl::WindowAspect x = aspect_.at(i);
					csLine.Format(L"%d:%d", x.ax, x.ay);
				} catch (...) {}
				break;
			}
		}
		wcsncpy_s(
			pDispInfo->item.pszText,
			pDispInfo->item.cchTextMax,
			csLine, _TRUNCATE);
	}

	if (pResult) { *pResult = 0; }
}



void CDisplayAspectDlg::OnLvnItemchangedListAspect(NMHDR *pNMHDR, LRESULT *pResult)
{
	int i = m_xcListAspect.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);

	if (i >= 0) // I
	{
		sl::WindowAspect x;
		try {
			x = aspect_.at(i);
		} catch(...) {}

		m_xcSpinAspect1.SetPos32(x.ax);
		m_xcSpinAspect2.SetPos32(x.ay);
		m_xcEditAspect1.EnableWindow(TRUE);
		m_xcSpinAspect1.EnableWindow(TRUE);
		m_xcEditAspect2.EnableWindow(TRUE);
		m_xcSpinAspect2.EnableWindow(TRUE);
	}
	else
	{
		m_xcEditAspect1.EnableWindow(FALSE);
		m_xcSpinAspect1.EnableWindow(FALSE);
		m_xcEditAspect2.EnableWindow(FALSE);
		m_xcSpinAspect2.EnableWindow(FALSE);
	}

	if (pResult) { *pResult = 0; }
}


void CDisplayAspectDlg::OnLvnColumnclickListAspect(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);
	if (!pNMLV) { return; }

	switch(pNMLV->iSubItem)
	{
	case 0:
		std::stable_sort(aspect_.begin(), aspect_.end(),
			[this](const sl::WindowAspect& l, const sl::WindowAspect& r)->bool{
				return orderAspect_ ? l.ax * l.ay > r.ax * r.ay : l.ax * l.ay < r.ax * r.ay;
		});
		m_xcListAspect.RedrawWindow();
		orderAspect_ = orderAspect_ ? false : true;
		break;

	default:
		break;
	}

	OnLvnItemchangedListAspect(0, 0);

	if (pResult) { *pResult = 0; }
}




void CDisplayAspectDlg::OnEnChangeEditAspect1()
{
	if (!IsWindow(m_xcListAspect.GetSafeHwnd())) { return; }

	int i = m_xcListAspect.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)aspect_.size()) { return; }

	if (!IsWindow(m_xcEditAspect1.GetSafeHwnd())) { return; }

	aspect_.at(i).ax = m_xcSpinAspect1.GetPos32();
	m_xcListAspect.Update(i);
}


void CDisplayAspectDlg::OnEnChangeEditAspect2()
{
	if (!IsWindow(m_xcListAspect.GetSafeHwnd())) { return; }

	int i = m_xcListAspect.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)aspect_.size()) { return; }

	if (!IsWindow(m_xcEditAspect2.GetSafeHwnd())) { return; }

	aspect_.at(i).ay = m_xcSpinAspect2.GetPos32();
	m_xcListAspect.Update(i);
}



void CDisplayAspectDlg::OnBnClickedBtnAspectUp()
{
	int i = m_xcListAspect.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)aspect_.size()) { return; }

	if (i <= 0) { return; }

	try {
		sl::WindowAspect x = aspect_.at(i - 1);
		aspect_.at(i - 1) = aspect_.at(i);
		aspect_.at(i) = x;

		m_xcListAspect.SetItemState(i - 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcListAspect.EnsureVisible(i - 1, FALSE);

		m_xcListAspect.RedrawWindow();
	} catch (...) {}
}





void CDisplayAspectDlg::OnBnClickedBtnAspectDown()
{
	int i = m_xcListAspect.GetNextItem(-1, LVNI_ALL | LVNI_SELECTED);
	if (i < 0 || i >= (int)aspect_.size()) { return; }

	// Xg̈ԉȂ̂ŉɂ͈ړłȂ
	if (i >= (int)(aspect_.size() - 1)) { return; }

	try {
		sl::WindowAspect x = aspect_.at(i + 1);
		aspect_.at(i + 1) = aspect_.at(i);
		aspect_.at(i) = x;

		m_xcListAspect.SetItemState(i + 1, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
		m_xcListAspect.EnsureVisible(i + 1, FALSE);

		m_xcListAspect.RedrawWindow();
	} catch (...) {}
}




void CDisplayAspectDlg::OnBnClickedBtnAspectAllDefault()
{
	sl::WindowConfig win;
	aspect_ = win.aspect;

	m_xcListAspect.SetItemCountEx(static_cast<int>(aspect_.size()), LVSICF_NOINVALIDATEALL|LVSICF_NOSCROLL);

	m_xcListAspect.SetItemState(0, LVIS_SELECTED|LVIS_FOCUSED, LVIS_SELECTED|LVIS_FOCUSED);
	m_xcListAspect.EnsureVisible(0, FALSE);
	m_xcListAspect.RedrawWindow();
}
