#pragma once
#include "afxcmn.h"

#include "VideoAdjustDlg.h"

#include "DetailNetworkDlg.h"
#include "DetailTypeDlg.h"
#include "DetailBrowserDlg.h"
#include "DetailStartDlg.h"
#include "DetailEndDlg.h"
#include "DetailDecoderDlg.h"
#include "DetailSnapshotDlg.h"
#include "DetailBoardDlg.h"

#include "OperationShortcutDlg.h"
#include "OperationMouseDlg.h"
#include "OperationVariationDlg.h"

#include "DisplayWindowDlg.h"
#include "DisplayAspectDlg.h"
#include "DisplayDatetimeDlg.h"
#include "DisplayStatusDlg.h"
#include "DisplaySeekDlg.h"
#include "DisplayHintDlg.h"
#include "DisplayChannelDlg.h"
#include "DisplayBBSDlg.h"
#include "DisplayResDlg.h"




// COptionDlg _CAO

class COptionDlg : public CDialog
{
	DECLARE_DYNAMIC(COptionDlg)

public:
	COptionDlg(CWnd* pParent = NULL);   // WRXgN^[
	virtual ~COptionDlg();

// _CAO f[^
	enum { IDD = IDD_OPTION };

	int select_;

	struct Video {
		CVideoAdjustDlg adjust;
	};

	struct Detail {
		CDetailNetworkDlg network;
		CDetailTypeDlg type;
		CDetailDecoderDlg decoder;
		CDetailBrowserDlg browser;
		CDetailSnapshotDlg snapshot;
		CDetailBoardDlg board;
		CDetailStartDlg start;
		CDetailEndDlg end;
	};

	struct Operation {
		COperationShortcutDlg shortcut;
		COperationMouseDlg mouse;
		COperationVariationDlg variation;
	};

	struct Display {
		CDisplayWindowDlg window;
		CDisplayAspectDlg aspect;
		CDisplayDatetimeDlg datetime;
		CDisplayStatusDlg status;
		CDisplaySeekDlg seek;
		CDisplayHintDlg hint;
		CDisplayChannelDlg channel;
		CDisplayBBSDlg bbs;
		CDisplayResDlg res;
	};

	Video video_;
	Detail detail_;
	Operation operation_;
	Display display_;

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

	CFont font_; // ^Cg̃tHg

	struct Item {
		HTREEITEM item;
		std::wstring title;
		CDialog* dlg;
	};

	std::vector<Item> vec_;

	void setTitle(const std::wstring& title);

	DECLARE_MESSAGE_MAP()
public:
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnTvnSelchangedTree(NMHDR *pNMHDR, LRESULT *pResult);

	CTreeCtrl m_xcTree;
};
