#include "stdafx.h"

namespace sl {

void put(XmlParser& p, const std::vector<DecoderInfo>& data)
{
	for (auto it = data.begin(); it != data.end(); ++it)
	{
		auto item = p.add(L"item");
		item.put(L"enable", it->enable);
		item.put(L"name", it->name);

		std::vector<OLECHAR> id;
		id.resize(1024, 0);
		StringFromGUID2(it->id, id.data(), (int)id.size());
		item.put(L"id", std::wstring(id.data()));
	}
}

void put(XmlParser& p, const std::vector<bbs::ReplaceElement>& data)
{
	for (auto it = data.begin(); it != data.end(); ++it)
	{
		auto item = p.add(L"item");
		item.put(L"enable", it->enable);
		item.put(L"desc", it->desc);
		item.put(L"regex", it->regex);
		item.put(L"format", it->format);
	}
}

void put(XmlParser& root, const DetailConfig& detail)
{
	auto p = root.put(L"detail");

	p = root.put(L"detail.network");
	p.put(L"stop", detail.network.stop);

	p = root.put(L"detail.network.retry");
	p.put(L"timeout", detail.network.retry.timeout);
	p.put(L"count", detail.network.retry.count);
	p.put(L"wait", detail.network.retry.wait);
	p.put(L"stop", detail.network.retry.stop);

	p = root.put(L"detail.network.rebuild");
	p.put(L"enable", detail.network.rebuild.enable);
	p.put(L"count", detail.network.rebuild.count);

	p = root.put(L"detail.network.reader");
	p.put(L"userAgent", detail.network.reader.userAgent);
	p.put(L"timeout", detail.network.reader.timeout);

	p = root.put(L"detail.type.flv");
	p.put(L"loop", detail.type.flv.loop);
	p.put(L"init", detail.type.flv.init);
	p.put(L"offset", detail.type.flv.offset);
	p.put(L"delay", detail.type.flv.delay);
	p.put(L"buffer", detail.type.flv.buffer);
	p.put(L"timestamp", detail.type.flv.timestamp);

	p = root.put(L"detail.decoder");
	p.put(L"dxva2", detail.decoder.dxva2);

	p = root.put(L"detail.video");
	put(p, detail.video);

	p = root.put(L"detail.audio");
	put(p, detail.audio);

	p = root.put(L"detail.browser");
	p.put(L"def", detail.browser.def);
	p.put(L"web", detail.browser.web);
	p.put(L"bbs", detail.browser.bbs);

	p = root.put(L"detail.snapshot");
	p.put(L"folder", detail.snapshot.folder);
	p.put(L"format", detail.snapshot.format);
	p.put(L"jpegQuality", detail.snapshot.jpegQuality);
	p.put(L"display", detail.snapshot.display);
	p.put(L"fit", detail.snapshot.fit);

	p = root.put(L"detail.board");
	p.put(L"contact", detail.board.contact);
	p.put(L"change", detail.board.change);
	p.put(L"userAgent", detail.board.userAgent);
	p.put(L"timeout", detail.board.timeout);
	p.put(L"shitaraba", detail.board.shitaraba);
	p.put(L"reload", detail.board.reload);
	p.put(L"interval", detail.board.interval);
	p.put(L"retry", detail.board.retry);
	p.put(L"stop", detail.board.stop);
	p.put(L"board", detail.board.board);
	p.put(L"res", detail.board.res);
	p.put(L"delay", detail.board.delay);
	p.put(L"position", detail.board.position);

	p = root.put(L"detail.board.url");
	put(p, detail.board.url);

	p = root.put(L"detail.board.message");
	put(p, detail.board.message);

	p = root.put(L"detail.start");
	p.put(L"recent", detail.start.recent);

	p = root.put(L"detail.end");
	p.put(L"pos", detail.end.pos);
	p.put(L"size", detail.end.size);
	p.put(L"aspect", detail.end.aspect);
	p.put(L"volume", detail.end.volume);
	p.put(L"balance", detail.end.balance);
	p.put(L"mute", detail.end.mute);
}

} // namespace sl
