#pragma once

namespace utl {

class WindowSnap
{
	int distance_;
	int x_;
	int y_;
	CRect diff_;

	inline bool snap(int a, int b);

public:
	WindowSnap();

	void OnEnterSizeMove(HWND hwnd);
	void OnMoving(HWND hwnd, LPRECT pRect, bool screen, bool window);

	bool screenSnapX(HWND hwnd, const MONITORINFO& mi, CRect& rc);
	bool screenSnapY(HWND hwnd, const MONITORINFO& mi, CRect& rc);
	bool windowSnapX(HWND hwnd, const CRect& org, CRect& rc);
	bool windowSnapY(HWND hwnd, const CRect& org, CRect& rc);
};

class SizeMove {
	bool sizemove_; // WM_ENTERSIZEMOVE/WM_EXITSIZEMOVE
	bool reset_;
	CRect rc_;

public:
	SizeMove()
		: sizemove_(false)
		, reset_(false)
	{}

	operator bool() { return sizemove_; }

	void setRect(const CRect& rc) { rc_ = rc; reset_ = true; }
	bool getRect(CRect& rc)
	{
		if (!reset_) { return false; }
		rc = rc_;
		reset_ = false;
		return true;
	}

	void OnEnterSizeMove() { sizemove_ = true; }
	void OnExitSizeMove() { sizemove_ = false; }
};

};